diff --git a/gnu/packages/dunst.scm b/gnu/packages/dunst.scm
deleted file mode 100644
index 4a8ff59ec9..0000000000
--- a/gnu/packages/dunst.scm
+++ /dev/null
@@ -1,89 +0,0 @@
-;;; GNU Guix --- Functional package management for GNU
-;;; Copyright © 2015, 2017, 2018 Alex Kost <alezost@gmail.com>
-;;; Copyright © 2018 Tobias Geerinckx-Rice <me@tobias.gr>
-;;; Copyright © 2019, 2023 Efraim Flashner <efraim@flashner.co.il>
-;;; Copyright © 2020 Brice Waegeneire <brice@waegenei.re>
-;;; Copyright © 2021 Alexandru-Sergiu Marton <brown121407@posteo.ro>
-;;; Copyright © 2021 Guillaume Le Vaillant <glv@posteo.net>
-;;; Copyright © 2022 Jai Vetrivelan <jaivetrivelan@gmail.com>
-;;;
-;;; This file is part of GNU Guix.
-;;;
-;;; GNU Guix is free software; you can redistribute it and/or modify it
-;;; under the terms of the GNU General Public License as published by
-;;; the Free Software Foundation; either version 3 of the License, or (at
-;;; your option) any later version.
-;;;
-;;; GNU Guix is distributed in the hope that it will be useful, but
-;;; WITHOUT ANY WARRANTY; without even the implied warranty of
-;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-;;; GNU General Public License for more details.
-;;;
-;;; You should have received a copy of the GNU General Public License
-;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
-
-(define-module (gnu packages dunst)
-  #:use-module (guix packages)
-  #:use-module (guix git-download)
-  #:use-module (guix build-system gnu)
-  #:use-module (guix utils)
-  #:use-module ((guix licenses) #:prefix license:)
-  #:use-module (gnu packages)
-  #:use-module (gnu packages base)
-  #:use-module (gnu packages freedesktop)
-  #:use-module (gnu packages glib)
-  #:use-module (gnu packages gnome)
-  #:use-module (gnu packages gtk)
-  #:use-module (gnu packages perl)
-  #:use-module (gnu packages pkg-config)
-  #:use-module (gnu packages xorg))
-
-(define-public dunst
-  (package
-    (name "dunst")
-    (version "1.9.0")
-    (source (origin
-              (method git-fetch)
-              (uri (git-reference
-                    (url "https://github.com/dunst-project/dunst")
-                    (commit (string-append "v" version))))
-              (file-name (git-file-name name version))
-              (sha256
-               (base32
-                "1nfxf2rahngxpy606yrizrz16d0pswl5sa9jfzpv7h19x6xy24vx"))))
-    (build-system gnu-build-system)
-    (arguments
-     `(#:tests? #f                      ; no check target
-       #:make-flags (list (string-append "CC=" ,(cc-for-target))
-                          (string-append "PREFIX=" %output)
-                          (string-append "SYSCONFDIR=" %output "/etc")
-                          ;; Otherwise it tries to install service file
-                          ;; to "dbus" store directory.
-                          (string-append "SERVICEDIR_DBUS=" %output
-                                         "/share/dbus-1/services")
-                          "dunstify")
-       #:phases (modify-phases %standard-phases
-                  (delete 'configure))))
-    (native-inputs
-     (list pkg-config perl ; for pod2man
-           which))
-    (inputs
-     (list dbus
-           (librsvg-for-system) ; for svg support
-           glib
-           cairo
-           pango
-           libnotify ; for dunstify
-           libx11
-           libxscrnsaver
-           libxinerama
-           libxrandr
-           libxdg-basedir
-           wayland))           ; for wayland support
-    (home-page "https://dunst-project.org/")
-    (synopsis "Customizable and lightweight notification daemon")
-    (description
-     "Dunst is a highly configurable and minimalistic notification daemon.
-It provides @code{org.freedesktop.Notifications} D-Bus service, so it is
-started automatically on the first call via D-Bus.")
-    (license license:bsd-3)))
diff --git a/gnu/packages/wm.scm b/gnu/packages/wm.scm
index 8576d0297d..2c2e908589 100644
--- a/gnu/packages/wm.scm
+++ b/gnu/packages/wm.scm
@@ -64,6 +64,7 @@
 ;;; Copyright © 2023 Jonathan Brielamier <jonathan.brielmaier@web.de>
 ;;; Copyright © 2023 Vessel Wave <vesselwave@disroot.org>
 ;;; Copyright © 2023 Nicolas Graves <ngraves@ngraves.fr>
+;;; Copyright © 2023 Jaeme Sifat <jaeme@runbox.com>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -1490,6 +1491,56 @@ (define-public cwm
 project derived from the original Calm Window Manager.")
     (license license:isc)))
 
+(define-public dunst
+  (package
+    (name "dunst")
+    (version "1.9.2")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/dunst-project/dunst")
+             (commit (string-append "v" version))))
+       (file-name (git-file-name name version))
+       (sha256
+        (base32 "17zrw7jrnlyln81pxw7p4jgvl7j1w1gf488nfskhns6j6dcz90gh"))))
+    (build-system gnu-build-system)
+    (arguments
+     (list
+      #:tests? #f ;no check target
+      #:make-flags #~(list (string-append "CC="
+                                          #$(cc-for-target))
+                           (string-append "PREFIX=" %output)
+                           (string-append "SYSCONFDIR=" %output "/etc")
+                           ;; Otherwise it tries to install service file
+                           ;; to "dbus" store directory.
+                           (string-append "SERVICEDIR_DBUS=" %output
+                                          "/share/dbus-1/services")
+                           "dunstify")
+      #:phases #~(modify-phases %standard-phases
+                   (delete 'configure))))
+    (native-inputs (list pkg-config perl ;for pod2man
+                         which))
+    (inputs (list dbus
+                  (librsvg-for-system) ;for svg support
+                  glib
+                  cairo
+                  pango
+                  libnotify ;for dunstify
+                  libx11
+                  libxscrnsaver
+                  libxinerama
+                  libxrandr
+                  libxdg-basedir
+                  wayland)) ;for wayland support
+    (home-page "https://dunst-project.org/")
+    (synopsis "Customizable and lightweight notification daemon")
+    (description
+     "Dunst is a highly configurable and minimalistic notification daemon.
+It provides @code{org.freedesktop.Notifications} D-Bus service, so it is
+started automatically on the first call via D-Bus.")
+    (license license:bsd-3)))
+
 (define-public dwl
   (package
     (name "dwl")